#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

int
main(int argc, char* argv[])
{
  FILE* f = stdin;
  char c;
  int newline = 1;

  if (argc != 3)
    {
      fprintf(stderr, "Usage: %s type color\n", argv[0]);
      exit(2);
    }

  if (getenv("TERM") && strcmp(getenv("TERM"), "dumb"))
    while ((c = fgetc(f)) != EOF)
      {
	if (newline)
	  {
	    fputc(033, stdout);
	    fputc('[', stdout);
	    fputs(argv[1], stdout);
	    fputc(';', stdout);
	    fputs(argv[2], stdout);
	    fputc('m', stdout);
	    fputc(033, stdout);
	    fputc('[', stdout);
	    fputc('K', stdout);
	    newline = 0;
	  }
	if (c == '\n')
	  {
	    fputc(033, stdout);
	    fputc('[', stdout);
	    fputc('m', stdout);
	    fputc(033, stdout);
	    fputc('[', stdout);
	    fputc('K', stdout);
	    fputc('\n', stdout);
	    fflush(stdout);
	    newline = 1;
	  }
	else
	  fputc(c, stdout);
      }
  else
    while ((c = fgetc(f)) != EOF)
      {
	fputc(c, stdout);
	if (c == '\n')
	  fflush(stdout);
      }
  fflush(stdout);
  return EXIT_SUCCESS;
}

